package treeificator

// Informers inform the parser about the prefix and suffix that make up a node
type Informer interface {
	// Get the prefix starting the informer's node type
	GetPrefix() string
	// Get the suffix starting the informer's node type
	GetSuffix() string
	// Get the name of the node type.
	// Each name (in lowercase) may only exist once. The parser will enforce this.
	// No guaranteed order for which informer will be used if multiple with the same name are in use.
	// The name "default" is occupied by the built-in default informer for just strings
	GetName() string
}

// Defa
type DefaultInformer struct{}

func (defaultinformer *DefaultInformer) GetPrefix() string {
	return ""
}
func (defaultinformer *DefaultInformer) GetSuffix() string {
	return ""
}
func (defaultinformer *DefaultInformer) GetName() string {
	return "default"
}
